import pygame
import math


__author__="mg"
__date__ ="$May 27, 2013 1:01:03 PM$"

class EnemyBomb(pygame.sprite.Sprite):
    def __init__(self,initial_position,soundStart,soundHit):
        pygame.sprite.Sprite.__init__(self)
        self.soundStart = soundStart
        self.soundHit = soundHit
        self.image = pygame.image.load("img/enemyBomb.png").convert_alpha()
        self.rect = self.image.get_rect()
        self.rect.topleft = initial_position
        self.speed = 100
        self.damage = 1
        self.soundStart.play(0)

    # hit(Sprite Enemy, timestamp )
    # Funktion wird aufgerufen sobald das Projektil einen Gegner trifft. Dieser wird bergeben
    # ret bool ob der Treffer den Gegner toetet
    def hit(self,enemy,timestamp):
        enemy.hitWith({self:timestamp})
        killed = enemy.dealDamage(self.damage)
        self.soundHit.play(0)
        self.kill()
        return killed

    def update(self,timestamp,time_passed):
        moved_distance = math.ceil(time_passed * self.speed)
        self.rect.top += moved_distance
        if self.rect.bottom < 0:
            self.kill()

