import pygame

# To change this template, choose Tools | Templates
# and open the template in the editor.

__author__="mg"
__date__ ="$Jun 3, 2013 4:59:33 PM$"


class Animation:
    @staticmethod
    def load_sliced_sprites(w, h, filename):
        images = []
        master_image = pygame.image.load(filename).convert_alpha()
        master_width, master_height = master_image.get_size()
        for i in xrange(int(master_width/w)):
            images.append(master_image.subsurface((i*w,0,w,h)))
        return images

    def __init__(self,list):
        self.frames = []
        self.current = 0

        self.fps = 30
        self.change_time = 1.0/self.fps
        self.time = 0

        self.killAfterComplete = False
        self.finished = False

        self.set_frames(list)
        self.reset_animation()
        
        self.loops = True
        self.current = 0
        self.image = self.frames[0]


    def set_frames(self,list):
        self.frames = list

    def set_loops(self,loops):
        self.loops = loops

    def add_frame(self,surface,pos = -1):
        if(pos >= len(self.frames) or pos < 0):
            self.frames.append(surface)
        else:
            self.frames.insert(pos,surface)

    def replace_frame(self,surface,pos):
        self.frames[pos] = surface


    def remove_frame(self,pos):
        self.frames.pop(pos)

    def set_framerate(self,rate):
        self.fps=rate
        self.change_time = 1.0/rate

    def get_frame(self,time_passed):
        self.time += time_passed
        #print("{0},{1}".format(self.time,self.change_time))
        if(self.time >= self.change_time):
            if(self.loops):
                self.current = (self.current + 1) % len(self.frames)
            else:
                if (self.current + 1 >= len(self.frames)):
                    self.current = len(self.frames)-1
                    self.finished = True
                else:
                    self.current = self.current + 1
            self.image = self.frames[self.current]
            self.time = 0
        return self.image

    def reset_animation(self):
        self.time = 0
        self.current=0

    def get_framerate(self):
        return self.fps



